#include <def21367.h>
#define N 128

.section/DATA64 seg_dmda;
.var input[N]="inwave.hex";
.var output[N];
.var delayline[5];

.section/DATA64 seg_pmda;
.var biquad[5]= "coeffs.dat";
.var expected[N]="expected_output.dat";

.section/pm seg_pmco;
.global _main;
_main:
//Enable Circular Buffers
bit set mode1 CBUFEN;
i0=delayline;   //Delayline Pointer
i4=input;       //Input Pointer
b5=output;      //Output Pointer
l5=N;           //Set output wrap length
b9=biquad;      //Biquad Coeffs pointer
l9=5;           //Set biquad wrap length

//Modifiers
m5=0;
m6=1;
m7=-1;
m14=1;

//Clear the multipliers
r6=0;
r7=0;
mrf=r6*r7(uuf);
mrb=r6*r7(uuf);

//Read first input, B0
r2=dm(i4,m6), r4=pm(i9,m14);

//Read X-1, B1
mrf=r2*r4(uuf),r0=dm(i0,m6),r4=pm(i9,m14);

//Adjust output pointer
r12=r12-r12,r12=dm(i5,m7);

//Read  Y-1
r13=r13-r13,r12=dm(m6,i0);

lcntr=N, do iir64_end until lce;

iir64_start:
    //Multiply lower halves in MRF
    //Read X-2, B2
    mrf=mrf + r0*r4 (uuf), r0=dm(i0,m6), r4=pm(i9,m14);
    //Read A1, Adjust DL pointer
    mrf=mrf + r0*r4 (uuf), r0=dm(i0,m6), r4=pm(i9,m14);
    //Read Y-1, A2
    mrf=mrf - r12*r4 (uuf), r0=dm(i0,m7), r4=pm(i9,m14);
    //Read Y-2, B0
    mrf=mrf - r0*r4 (uuf), r0=dm(i0,m7), r4=pm(i9,m14);

    //Copy from most significant 32-bits of the low half multiplication
    r7=0;
    r6=mr1f;
    mr1b=r7;
    mr0b=r6;

    //Cross multiply upper and lower halves in MRB
    //Multiply upper halves in MRF
    //Read Y-1
    mrf=r3*r5 (ssf);
    mrb=mrb+r3*r4 (suf),r0=dm(i0,m7);
    //Read X-1, B1
    mrb=mrb+r5*r2 (suf),r0=dm(i0,m5),r4=pm(i9,m14);
    //Update X-1
    mrf=mrf+r1*r5 (ssf);
    mrb=mrb+r1*r4 (suf), dm(i0,m6)=r2;
    //Read X-2, B2
    mrb=mrb+r5*r0 (suf), r2=dm(i0,m5),r4=pm(i9,m14);
    //Update X-2
    mrf=mrf+r3*r5 (ssf);
    mrb=mrb+r3*r4 (suf), dm(i0,m6)=r0;
    //Read Y-1, A1
    mrb=mrb+r5*r2 (suf), r0=dm(i0,m6),r4=pm(i9,m14);
    //Store output
    mrf=mrf-r1*r5 (ssf), dm(i5,m6)=r12;
    //Read Y-2
    mrb=mrb-r1*r4 (suf), r2=dm(i0,m5);
    //Update Y-2, read A2
    mrb=mrb-r5*r0 (suf), dm(i0,m7)=r0, r4=pm(i9,m14);
    //Modify DL Pointer
    mrf=mrf-r3*r5 (ssf), modify(i0,m7);
    //Modify DL Pointer
    mrb=mrb-r3*r4 (suf), modify(i0,m7);
    //Read X-1
    mrb=mrb-r5*r2 (suf), r0=dm(i0,m6);

    //Collect MRB and MRF into registers for final addition
    //Modify DL Pointer
    r12=mr0f,modify(i0,m6);
    r13=mr1f;
    r6=mr0b;
    r7=mr1b;

    //Shift result of mixed multiplies by 31 bits
    r6=lshift r6 by -31;
    r6=r6 OR lshift r7 by 1;
    r7=lshift r7 by -31;

    //Final 64-bit addition of MRB and MRF
    //Read next input, B0
    r12=r12+r6,r2=dm(i4,m6), r4=pm(i9,m14);
    r13=r13+r7+CI;

    //Update Y-1, read B1
iir64_end: mrf=r2*r4 (uuf), dm(i0,m7)=r12, r4=pm(i9,m14);

//Save final output
dm(i5,m6)=r12;

_main.end: jump(pc,0);
